﻿# 阅读实验源代码
**main.c文件**  
在main函数中实现了单链表的初始化，然后调用了两次单链表的插入函数InsertBefore，第一次调用插入成功，第二次调用插入失败，并在main函数的最后销毁了单链表。  
在main函数的后面，定义了单链表的插入函数InsertBefore，此函数的函数体还不完整，留给读者完成。  
**SingleLinkList.h文件**   
定义了与单链表相关的数据结构并声明了相关的操作函数。  
# 在演示模式下调试项目
**按照下面的步骤调试项目：**
1.	按F7生成项目。
2.	在演示模式下，按F5启动调试项目。程序会在观察点函数的开始位置中断。
3.	重复按F5，直到调试过程结束。

在调试的过程中，每执行“演示流程”窗口中的一行后，仔细观察“可视化数据”窗口内容所发生的变化，理解在单链表中插入元素的执行过程。“可视化数据”窗口显示了单链表（pListHead）的数据信息（如下图所示），包括：
- 	单链表中元素在内存中的地址。由于在初始化时，单链表的元素是连续分配的，所以可能有部分相邻元素的地址是连续的，但是，从所有元素的地址上观察，可以发现地址是非连续的，特别是有新元素插入后。
- 	单链表中元素的值。头节点的值被忽略。
- 	前一个结点的指针指向了后一个结点的地址。
- 	用绿色的边框标识出了结点的插入位置。
- 	在调试的过程中，可以看到游标的移动。
- 	新插入的结点用红色的边框标识出来。

![单链表的插入操作](./img/4.png)

# 编写源代码并通过验证
**按照下面的步骤继续实验：**
1.	为InsertBefore函数编写源代码。注意，尽量使用已定义的局部变量。
2.	按F7生成项目。如果生成失败，根据“输出”窗口中的提示信息修改源代码中的语法错误。
3.	按Alt+F5启动验证。如果验证失败，可以使用“输出”窗口中的“比较”功能，或者在“非演示模式”下按F5启动调试后重复按F10单步调试读者编写的源代码，从而定位错误的位置，然后回到步骤1。

# 教师参考答案
访问教师参考答案[domain relative url](engintime/ds-lab/teachers-packet/Lab004.git)